#include <cstdio>
#include <cstdlib>
#include <vector>
#include <array>
#include "island.h"

static int N, C = 0;
static bool reported = false;
static std::vector<std::array<int,3>>added;


void my_assert(bool x, char *msg){
	if(!x){
	    printf("%s\n", msg);
		exit(0);
	}
}

int add_vertex(int i, int j, int k){
    my_assert(!reported, "add_vertex called after report");
    added.push_back({i,j,k});
    N++;
    return N-1;
}

void report(std::vector<std::array<int, 2>> tree){
    reported = true;
    C++;
    printf("%d\n%d\n", C, (int)(tree.size()));
    for(auto &[u, v]: tree){
        printf("%d %d\n",u, v);
    }
}

int main(){
	scanf("%d", &N);
	std::vector<int> U(N-3), V(N-3);
	for(int i = 0; i < N-3; i++){
	    scanf("%d%d",&U[i],&V[i]);
	}
	construct_two_trees(N, U, V);
    printf("%d\n",(int)added.size());
    for(auto &triangle: added){
        printf("%d %d %d\n",triangle[0],triangle[1],triangle[2]);
    }
}